<!-- Build script for marcupload form -->

<project name="marcupload" default="compile" basedir=".">

<property file="${user.home}/build.properties"/>

<property name="src" 		value="${basedir}/src"/>
<property name="build" 		value="${basedir}/tmp"/>
<property name="dist" 		value="${basedir}/dist"/>
<property name="api" 		value="${basedir}/doc/api"/>
<property name="lib" 		value="${basedir}/lib"/>
<property name="filtered"	value="${build}/filtered"/>
<property name="test"       value="${basedir}/doc/test"/>

<property name="appName" 	       value="marcupload"/>
<property name="compile.debug"       value="true"/>
<property name="compile.deprecation" value="true"/>

<path id="classpath">
	<!--Put needed packages in the classpath-->
	<fileset dir="${jars.home}">
		<include name="servlet.jar"/>
        <include name="marc4j.jar"/>
	</fileset>
	<pathelement location="${build}/classes"/>
</path>

<!-- common config -->
<import file="../common/remote.xml"/>
<import file="../common/version.xml"/>

<!--======================================================================-->
<!-- PREPARE -->
<!--======================================================================-->
<target name="prepare" description="Create needed folders">
	<!-- Create the build directory structure -->
	<mkdir dir="${build}/classes"/>
	<mkdir dir="${api}"/>
	<mkdir dir="${dist}"/>
	<mkdir dir="${filtered}"/>
	<mkdir dir="${test}"/>	
	<mkdir dir="${lib}"/>	
</target>

<!--======================================================================-->
<!-- COMPILE -->
<!--======================================================================-->
<target name="compile" depends="clean, prepare, version"
    description="Compile sources">

    <!--***************************************************************-->
    <!-- Perform filter operations -->
    <!--***************************************************************-->
        <copy todir="${filtered}" overwrite="true">
            <fileset dir="${src}">
                <include name="**/*"/>
            </fileset>
        
            <filterset refid="version-filters"/>
        </copy>
    <!--***************************************************************-->
    <javac debug="${compile.debug}" deprecation="${compile.deprecation}" 
        destdir="${build}/classes" srcdir="${filtered}/java" target="1.5">
        <classpath refid="classpath"/>
    </javac>

</target>

<!--======================================================================-->
<!-- JAVADOC -->
<!--======================================================================-->
<target name="javadoc" depends="clean" description="Create JavaDocs">
	<javadoc destdir="${api}" packagenames="edu.ucsd.library.${appName}.*"
         author="true">
		<sourcepath>
			<pathelement location="${src}/java"/>
		</sourcepath>
	</javadoc>
</target>

<!--======================================================================-->
<!-- CLEAN -->
<!--======================================================================-->
<target name="clean" description="Delete build, dist, and api directory">
    <delete dir="${build}"/>
    <delete dir="${dist}"/>
    <delete dir="${api}"/>
    <delete dir="${filtered}"/>
    <delete dir="${test}"/>
</target>

<!--======================================================================-->
<!-- DEPLOY -->
<!--======================================================================-->
<target name="deploy" depends="webapp"
    description="Deploy application to servlet container">

    <!-- Remove existing instances -->
    <delete file="${deploy.home}/${appName}.war"/>
    <delete dir="${deploy.home}/${appName}" />
    
    <!-- Deploying to webapps directory -->
    <unwar src="${dist}/${appName}.war" dest="${deploy.home}/${appName}" />
    
  	<mkdir dir="${deploy.home}/${appName}/raw"/>
    
    <!-- Copy the JARS to the Tomcat shared library -->
    <copy todir="${catalina.sharedlib}" >
    	<fileset dir="${jars.home}" >
    		<include name="**/*.jar"/>
    	</fileset>
    </copy>
    
</target>
<!--======================================================================-->
<!-- DEPLOY CLEAN-->
<!--======================================================================-->
<target name="deployclean" depends="deploy" description="deploys, then cleans...">
    <delete dir="${build}"/>
    <delete dir="${dist}"/>
    <delete dir="${api}"/>
    <delete dir="${filtered}"/>
    <delete dir="${test}"/>
</target>
<!--======================================================================-->
<!-- WEBAPP -->
<!--======================================================================-->
<target name="webapp" depends="compile" description="Creates a Web Archive">

    <war warfile="${dist}/${appName}.war" webxml="${filtered}/webinf/web.xml">
<!--
        <fileset dir="${filtered}">
            <include name="html/**/*.*"/>
            <include name="jsp/**/*.*"/>
        </fileset>
-->
        <fileset dir="${filtered}/html"/>

        <fileset dir="${filtered}/jsp"/>
        <lib dir="${lib}" />
        <classes dir="${build}/classes" />
        <webinf dir="${filtered}/webinf" excludes="web.xml" />
        <metainf dir="${filtered}/metainf"/>
    </war>
</target>

</project>
